diff --git a/dlls/ntdll/signal_x86_64.c b/dlls/ntdll/signal_x86_64.c
index 0ccc7cbceb6..149ad1bf5e7 100644
--- a/dlls/ntdll/signal_x86_64.c
+++ b/dlls/ntdll/signal_x86_64.c
@@ -24,6 +24,7 @@
 #include "wine/port.h"
 
 #include <assert.h>
+#include <errno.h>
 #include <signal.h>
 #include <stdlib.h>
 #include <stdarg.h>
@@ -59,6 +60,13 @@
 # include <mach/mach.h>
 #endif
 
+#if defined(HAVE_LINUX_FILTER_H) && defined(HAVE_LINUX_SECCOMP_H) && defined(HAVE_SYS_PRCTL_H)
+#define HAVE_SECCOMP 1
+# include <linux/filter.h>
+# include <linux/seccomp.h>
+# include <sys/prctl.h>
+#endif
+
 #define NONAMELESSUNION
 #define NONAMELESSSTRUCT
 #include "ntstatus.h"
@@ -76,6 +84,8 @@
 
 WINE_DEFAULT_DEBUG_CHANNEL(seh);
 
+extern void DECLSPEC_NORETURN __wine_syscall_dispatcher( void );
+
 typedef struct _SCOPE_TABLE
 {
     ULONG Count;
@@ -2797,6 +2807,104 @@ static void usr1_handler( int signal, siginfo_t *siginfo, void *ucontext )
     restore_context( &context, ucontext );
 }
 
+extern unsigned int __wine_nb_syscalls;
+
+#ifdef HAVE_SECCOMP
+static void sigsys_handler( int signal, siginfo_t *siginfo, void *sigcontext )
+{
+    unsigned int thunk_ret_offset;
+    ucontext_t *ctx = sigcontext;
+    unsigned int syscall_nr;
+    void ***rsp;
+
+    WARN("SIGSYS, rax %#llx.\n", ctx->uc_mcontext.gregs[REG_RAX]);
+
+    syscall_nr = ctx->uc_mcontext.gregs[REG_RAX] - 0xf000;
+    if (syscall_nr >= __wine_nb_syscalls)
+    {
+        ERR("Syscall %u is undefined.\n", syscall_nr);
+        return;
+    }
+
+    rsp = (void ***)&ctx->uc_mcontext.gregs[REG_RSP];
+    *rsp -= 1;
+
+#ifdef __APPLE__
+    thunk_ret_offset = 0xb;
+#else
+    thunk_ret_offset = 0xc;
+#endif
+
+    **rsp = (void *)(ctx->uc_mcontext.gregs[REG_RIP] + thunk_ret_offset);
+    ctx->uc_mcontext.gregs[REG_RIP] = (ULONG64)__wine_syscall_dispatcher;
+}
+#endif
+
+#ifdef HAVE_SECCOMP
+static int sc_seccomp(unsigned int operation, unsigned int flags, void *args)
+{
+#ifndef __NR_seccomp
+#   define __NR_seccomp 317
+#endif
+    return syscall(__NR_seccomp, operation, flags, args);
+}
+#endif
+
+static void install_bpf(struct sigaction *sig_act)
+{
+#ifdef HAVE_SECCOMP
+#   ifndef SECCOMP_FILTER_FLAG_SPEC_ALLOW
+#       define SECCOMP_FILTER_FLAG_SPEC_ALLOW (1UL << 2)
+#   endif
+
+#   ifndef SECCOMP_SET_MODE_FILTER
+#       define SECCOMP_SET_MODE_FILTER 1
+#   endif
+    static const unsigned int flags = SECCOMP_FILTER_FLAG_SPEC_ALLOW;
+    static struct sock_filter filter[] =
+    {
+       BPF_STMT(BPF_LD | BPF_W | BPF_ABS,
+                (offsetof(struct seccomp_data, nr))),
+       BPF_JUMP(BPF_JMP | BPF_JGE | BPF_K, 0xf000, 0, 1),
+       BPF_STMT(BPF_RET | BPF_K, SECCOMP_RET_TRAP),
+       BPF_STMT(BPF_RET | BPF_K, SECCOMP_RET_ALLOW),
+    };
+    struct sock_fprog prog;
+    int ret;
+
+    memset(&prog, 0, sizeof(prog));
+    prog.len = ARRAY_SIZE(filter);
+    prog.filter = filter;
+
+    if (!(ret = prctl(PR_GET_SECCOMP, 0, NULL, 0, 0)))
+    {
+        if (prctl(PR_SET_NO_NEW_PRIVS, 1, 0, 0, 0))
+        {
+            perror("prctl(PR_SET_NO_NEW_PRIVS, ...)");
+            exit(1);
+        }
+
+        if (sc_seccomp(SECCOMP_SET_MODE_FILTER, flags, &prog))
+
+        {
+            perror("prctl(PR_SET_SECCOMP, ...)");
+            exit(1);
+        }
+    }
+    else
+    {
+        if (ret == 2)
+            TRACE("Seccomp filters already installed.\n");
+        else
+            ERR("Seccomp filters cannot be installed, ret %d, error %s.\n", ret, strerror(errno));
+    }
+
+    sig_act->sa_sigaction = sigsys_handler;
+    sigaction(SIGSYS, sig_act, NULL);
+#else
+    WARN("Built without seccomp.\n");
+#endif
+}
 
 /***********************************************************************
  *           __wine_set_signal_handler   (NTDLL.@)
@@ -2842,6 +2950,9 @@ void signal_init_process(void)
     sig_act.sa_sigaction = trap_handler;
     if (sigaction( SIGTRAP, &sig_act, NULL ) == -1) goto error;
 #endif
+
+    install_bpf(&sig_act);
+
     return;
 
  error:
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 6ac5c993508..bd1999ac601 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -496,7 +496,7 @@ static void output_syscall_thunks_x64( DLLSPEC *spec )
         output_cfi( ".cfi_startproc" );
         output( "\t.byte 0x4c,0x8b,0xd1\n" );                               /* mov r10, rcx */
         output( "\t.byte 0xb8\n" );                                         /* mov eax, SYSCALL */
-        output( "\t.long %d\n", i );
+        output( "\t.long %d\n", i + 0xf000 );
         output( "\t.byte 0xf6,0x04,0x25,0x08,0x03,0xfe,0x7f,0x01\n" );      /* test byte ptr [0x7ffe0308], 1 */
         output( "\t.byte 0x75,0x03\n" );                                    /* jne (over syscall) */
         output( "\t.byte 0x0f,0x05\n" );                                    /* syscall */
@@ -541,6 +541,9 @@ static void output_syscall_thunks_x64( DLLSPEC *spec )
         output( "\t.byte %d\n", max(get_args_size(odp), 32) - 32 );
     }
 
+    output( "%s\n", asm_globl("__wine_nb_syscalls") );
+    output( "\t.long %u\n", spec->nb_syscalls );
+
     output( "\n/* syscall dispatcher */\n\n" );
     output( "\t.text\n" );
     output( "\t.align %d\n", get_alignment(16) );
@@ -566,6 +569,8 @@ static void output_syscall_thunks_x64( DLLSPEC *spec )
     else
         output( "\tsubq $0xc,0x8(%%rbp)\n" );
 
+    output( "\tsub $0xf000,%%rax\n" );
+
     /* copy over any arguments on the stack */
     output( "\tleaq 0x38(%%rbp),%%rsi\n" );
     if (UsePIC)
-- 
2.27.0

>From 83a5ab8b9eca4dbac48670c0c737b4d6e819d4a0 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 18 Jun 2020 18:11:26 +0200
Subject: [PATCH 31/32] ntdll: Introduce __wine_fakedll_init function.
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Based on a patch by Michael Müller <michael@fds-team.de>
---
 dlls/ntdll/loader.c      |  2 ++
 dlls/ntdll/thread.c      |  9 +++++++
 dlls/ntdll/unix/loader.c | 52 ++++++++++++++++++++++++++++++++++++++++
 include/winternl.h       |  2 +-
 4 files changed, 64 insertions(+), 1 deletion(-)

diff --git a/dlls/ntdll/loader.c b/dlls/ntdll/loader.c
index 902c347705f..44c3e4ab8d8 100644
--- a/dlls/ntdll/loader.c
+++ b/dlls/ntdll/loader.c
@@ -3816,6 +3816,7 @@ PIMAGE_NT_HEADERS WINAPI RtlImageNtHeader(HMODULE hModule)
 }
 
 extern void DECLSPEC_NORETURN __wine_syscall_dispatcher( void );
+extern void WINAPI __wine_fakedll_init( IMAGE_NT_HEADERS * );
 
 /******************************************************************
  *		LdrInitializeThunk (NTDLL.@)
@@ -3834,6 +3835,7 @@ void WINAPI LdrInitializeThunk( CONTEXT *context, void **entry, ULONG_PTR unknow
     LPCWSTR load_path = NtCurrentTeb()->Peb->ProcessParameters->DllPath.Buffer;
 
     NtCurrentTeb()->WOW32Reserved = __wine_syscall_dispatcher;
+    NtCurrentTeb()->Spare2 = (ULONG_PTR)__wine_fakedll_init;
 
     pthread_sigmask( SIG_UNBLOCK, &server_block_set, NULL );
 
diff --git a/dlls/ntdll/thread.c b/dlls/ntdll/thread.c
index 8e856422be2..89df2dbdc54 100644
--- a/dlls/ntdll/thread.c
+++ b/dlls/ntdll/thread.c
@@ -175,6 +175,14 @@ int __cdecl __wine_dbg_output( const char *str )
 
 extern void DECLSPEC_NORETURN __wine_syscall_dispatcher( void );
 
+void WINAPI __wine_fakedll_init( IMAGE_NT_HEADERS *nt )
+{
+    HMODULE module = (HMODULE)((UINT_PTR)nt & ~0xffff);
+    IMAGE_NT_HEADERS tmp = *nt;
+    tmp.OptionalHeader.ImageBase = (DWORD_PTR)module;
+    unix_funcs->map_so_dll( &tmp, module );
+}
+
 /***********************************************************************
  *           thread_init
  *
@@ -190,6 +198,7 @@ TEB *thread_init( SIZE_T *info_size, BOOL *suspend )
 
     teb = unix_funcs->init_threading( &nb_threads, &__wine_ldt_copy, info_size, suspend, &server_cpus,
                                       &is_wow64, &server_start_time, __wine_syscall_dispatcher );
+    teb->Spare2 = (ULONG_PTR)__wine_fakedll_init;
 
     peb = teb->Peb;
     peb->FastPebLock        = &peb_lock;
diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index 496beeba913..576622031ff 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -745,6 +745,13 @@ static NTSTATUS remap_writable( void *addr, size_t size )
 }
 
 
+struct __wine_spec_func_table
+{
+    size_t name_offset;
+    void *func_ptrs[0];
+};
+
+
 /*************************************************************************
  *		map_so_dll
  *
@@ -752,6 +759,8 @@ static NTSTATUS remap_writable( void *addr, size_t size )
  */
 static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE module )
 {
+    static char const *subdirs[] = {"dlls", "programs"};
+
     IMAGE_DATA_DIRECTORY *dir;
     IMAGE_DOS_HEADER *dos;
     IMAGE_NT_HEADERS *nt;
@@ -760,6 +769,9 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     int delta;
     unsigned int i;
     DWORD size = nt_descr->OptionalHeader.SizeOfHeaders;
+    struct __wine_spec_func_table *fake_table, *unix_table;
+    char path[MAX_PATH], *name, *dll_name;
+    void *handle;
 
     if ((delta = (const BYTE *)nt_descr->OptionalHeader.ImageBase - addr))
     {
@@ -851,6 +863,46 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
         fixup_rva_dwords( (DWORD *)(addr + exports->AddressOfNames), delta, exports->NumberOfNames );
         fixup_rva_dwords( (DWORD *)(addr + exports->AddressOfFunctions), delta, exports->NumberOfFunctions );
     }
+
+    /* fill the fakedll function table */
+
+    dir = &nt->OptionalHeader.DataDirectory[15];
+    if (dir->Size)
+    {
+        fake_table = (struct __wine_spec_func_table *)(addr + dir->VirtualAddress);
+        dll_name = (char *)&fake_table->func_ptrs + fake_table->name_offset;
+
+        name = build_path( dll_dir, dll_name );
+        handle = dlopen(name, RTLD_NOW);
+        free(name);
+
+        for (i = 0; !handle && build_dir && i < ARRAY_SIZE(subdirs); ++i)
+        {
+            if ((name = remove_tail( dll_name, ".dll.so" )))
+                sprintf(path, "%s/%s/%s/%s.dll.so", build_dir, subdirs[i], name, name);
+            else if ((name = remove_tail( dll_name, ".exe.so" )))
+                sprintf(path, "%s/%s/%s/%s.exe.so", build_dir, subdirs[i], name, name);
+            else if ((name = remove_tail( dll_name, ".so" )))
+                sprintf(path, "%s/%s/%s/%s.so", build_dir, subdirs[i], name, name);
+            else
+                continue;
+
+            handle = dlopen(path, RTLD_NOW);
+            free(name);
+        }
+
+        for (i = 0; !handle && dll_paths[i]; ++i)
+        {
+            name = build_path( dll_paths[i], dll_name );
+            handle = dlopen(name, RTLD_NOW);
+            free(name);
+        }
+
+        unix_table = dlsym(handle, "__wine_spec_unix_funcs");
+        assert(unix_table->name_offset == fake_table->name_offset);
+        memcpy(&fake_table->func_ptrs, &unix_table->func_ptrs, fake_table->name_offset);
+    }
+
     return STATUS_SUCCESS;
 }
 
diff --git a/include/winternl.h b/include/winternl.h
index ff6916c98e7..d8d67c513a9 100644
--- a/include/winternl.h
+++ b/include/winternl.h
@@ -398,7 +398,7 @@ typedef struct _TEB
     PVOID                        Instrumentation[16];               /* f2c/16b8 */
     PVOID                        WinSockData;                       /* f6c/1738 */
     ULONG                        GdiBatchCount;                     /* f70/1740 */
-    ULONG                        Spare2;                            /* f74/1744 */
+    ULONG                        Spare2;                            /* f74/1744  used for fakedll thunks */
     ULONG                        GuaranteedStackBytes;              /* f78/1748 */
     PVOID                        ReservedForPerf;                   /* f7c/1750 */
     PVOID                        ReservedForOle;                    /* f80/1758 */
-- 
2.27.0

>From 6650363b56ba519135d9debe3fd54cbc948a2a51 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 18 Jun 2020 10:07:10 +0200
Subject: [PATCH 32/32] winebuild: Generate fakedll function tables.

---
 tools/winebuild/spec32.c | 171 ++++++++++++++++++++++++++++++++++++++-
 1 file changed, 168 insertions(+), 3 deletions(-)

diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index bd1999ac601..674c2aa2671 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -609,6 +609,172 @@ static void output_syscall_thunks_x64( DLLSPEC *spec )
     output_function_size( "__wine_syscall_dispatcher" );
 }
 
+void output_fakedll_dispatcher( DLLSPEC *spec )
+{
+    char *so_name, name[256];
+    int i;
+
+    if (target_platform == PLATFORM_WINDOWS) return;
+
+    output( "\n/* fakedll dispatcher thunks */\n\n" );
+    output( "\t.text\n" );
+    for (i = 0; i < spec->nb_entry_points; i++)
+    {
+        ORDDEF *odp = &spec->entry_points[i];
+        if (odp->type != TYPE_STDCALL && odp->type != TYPE_VARARGS && odp->type != TYPE_CDECL)
+            continue;
+        if (odp->flags & (FLAG_FORWARD|FLAG_IMPORT|FLAG_EXT_LINK))
+            continue;
+
+        sprintf(name, "__wrap_%s", get_link_name(odp));
+        output( "\t.ifndef %s\n", asm_name(name) );
+        output( "\t.align %d\n", get_alignment(0x100) );
+        output( "\t%s\n", func_declaration(name) );
+        output( "%s\n", asm_globl(name) );
+        output_cfi( ".cfi_startproc" );
+        switch(target_cpu)
+        {
+        case CPU_x86:
+            output( "\t.byte 0x8b,0xff,0x55,0x8b,0xec,0x5d\n" );  /* hotpatch prolog */
+            output( "\tpushl %%eax\n" );
+            if (UsePIC)
+            {
+                output( "\tcall %s\n", asm_name("__wine_spec_get_pc_thunk_eax") );
+                output( "1:\tleal .L__wine_spec_fake_ptrs+%d-1b(%%eax),%%eax\n", i * get_ptr_size() );
+                needs_get_pc_thunk = 1;
+            }
+            else output( "\tleal .L__wine_spec_fake_ptrs+%d,%%eax\n", i * get_ptr_size() );
+            output( "\tcmpl $0,0(%%eax)\n" );
+            output( "\tje %s\n", asm_name("__wine_fakedll_init_asm") );
+            output( "\tmovl 0(%%eax),%%eax\n" );
+            output( "\txchgl 0(%%esp),%%eax\n" );
+            output( "\tretl\n" );
+            break;
+        case CPU_x86_64:
+            output( "\t.byte 0x48\n" );  /* hotpatch prolog */
+            output( "\tpushq %%rax\n" );
+            output( "\tleaq .L__wine_spec_fake_ptrs+%d(%%rip),%%rax\n", i * get_ptr_size() );
+            output( "\tcmpq $0,0(%%rax)\n" );
+            output( "\tje %s\n", asm_name("__wine_fakedll_init_asm") );
+            output( "\tmovq 0(%%rax),%%rax\n" );
+            output( "\txchgq 0(%%rsp),%%rax\n" );
+            output( "\tretq\n" );
+            break;
+        default:
+            assert(0);
+            break;
+        }
+        output_cfi( ".cfi_endproc" );
+        output( "\t.align %d\n", get_alignment(0x100) );
+        output_function_size( name );
+        output( "\t.endif\n" );
+    }
+
+    output( "\t.text\n" );
+    output( "\t.align %d\n", get_alignment(8) );
+    output( "\t%s\n", func_declaration("__wine_fakedll_init_asm") );
+    output( "%s:\n", asm_name("__wine_fakedll_init_asm") );
+    output_cfi( ".cfi_startproc" );
+    switch(target_cpu)
+    {
+    case CPU_x86:
+        output( "\tpushl %%eax\n" );
+        output( "\tpushl %%ecx\n" );
+        output( "\tpushl %%edx\n" );
+        output( "\tpushl $%s\n", asm_name("__wine_spec_nt_header") );
+        output( "\tcall *%%fs:0xf74\n" );
+        output( "\tpopl %%edx\n" );
+        output( "\tpopl %%ecx\n" );
+        output( "\tpopl %%eax\n" );
+        output( "\tmovl 0(%%eax),%%eax\n" );
+        output( "\txchgl 0(%%esp),%%eax\n" );
+        output( "\tretl\n" );
+        break;
+    case CPU_x86_64:
+        output( "\tsubq $0x100,%%rsp\n" );
+        output_cfi( ".cfi_adjust_cfa_offset 0x100" );
+        output( "\tmovq %%rax,0x90(%%rsp)\n" );
+        output( "\tmovq %%rdx,0x88(%%rsp)\n" );
+        output( "\tmovq %%rcx,0x80(%%rsp)\n" );
+        output( "\tmovq %%r8,0x78(%%rsp)\n" );
+        output( "\tmovq %%r9,0x70(%%rsp)\n" );
+        output( "\tmovq %%r10,0x68(%%rsp)\n" );
+        output( "\tmovq %%r11,0x60(%%rsp)\n" );
+        output( "\tmovups %%xmm0,0x50(%%rsp)\n" );
+        output( "\tmovups %%xmm1,0x40(%%rsp)\n" );
+        output( "\tmovups %%xmm2,0x30(%%rsp)\n" );
+        output( "\tmovups %%xmm3,0x20(%%rsp)\n" );
+        output( "\tleaq %s(%%rip),%%rcx\n", asm_name("__wine_spec_nt_header") );
+        output( "\tcall *%%gs:0x1744\n" );
+        output( "\tmovups 0x20(%%rsp),%%xmm3\n" );
+        output( "\tmovups 0x30(%%rsp),%%xmm2\n" );
+        output( "\tmovups 0x40(%%rsp),%%xmm1\n" );
+        output( "\tmovups 0x50(%%rsp),%%xmm0\n" );
+        output( "\tmovq 0x60(%%rsp),%%r11\n" );
+        output( "\tmovq 0x68(%%rsp),%%r10\n" );
+        output( "\tmovq 0x70(%%rsp),%%r9\n" );
+        output( "\tmovq 0x78(%%rsp),%%r8\n" );
+        output( "\tmovq 0x80(%%rsp),%%rcx\n" );
+        output( "\tmovq 0x88(%%rsp),%%rdx\n" );
+        output( "\tmovq 0x90(%%rsp),%%rax\n" );
+        output( "\taddq $0x100,%%rsp\n" );
+        output_cfi( ".cfi_adjust_cfa_offset -0x100" );
+        output( "\tmovq 0(%%rax),%%rax\n" );
+        output( "\txchgq 0(%%rsp),%%rax\n" );
+        output( "\tretq\n" );
+        break;
+    default:
+        assert(0);
+        break;
+    }
+    output_cfi( ".cfi_endproc" );
+    output_function_size( "__wine_fakedll_init_asm" );
+    output( "\n" );
+
+    so_name = strdup(spec->file_name);
+    for (i = 0; so_name[i]; ++i) so_name[i] = tolower(so_name[i]);
+
+    output( "\n/* fakedll dispatcher tables */\n\n" );
+    output( "\t%s\n", get_asm_data_section() );
+    output( "\t.align %d, 0\n", get_alignment(4) );
+    output( "%s\n", asm_globl("__wine_spec_fake_funcs") );
+    output( ".L__wine_spec_fake_funcs:\n" );
+    output( "\t%s .L__wine_spec_fake_name-.L__wine_spec_fake_ptrs\n", get_asm_ptr_keyword() );
+    output( ".L__wine_spec_fake_ptrs:\n" );
+    for (i = 0; i < spec->nb_entry_points; i++)
+        output( "\t%s 0\n", get_asm_ptr_keyword() );
+    output( ".L__wine_spec_fake_name:\n" );
+    output( "\t.ascii \"%s.so\"\n", so_name );
+    output( "\t.long 0\n" );
+    output( ".L__wine_spec_fake_funcs_end:\n" );
+
+    output( "\t%s\n", get_asm_data_section() );
+    output( "\t.globl %s\n", asm_name("__wine_spec_unix_funcs") );
+    output( "%s:\n", asm_name("__wine_spec_unix_funcs") );
+    output( ".L__wine_spec_unix_funcs:\n" );
+    output( "\t%s .L__wine_spec_unix_name-.L__wine_spec_unix_ptrs\n", get_asm_ptr_keyword() );
+    output( ".L__wine_spec_unix_ptrs:\n" );
+    for (i = 0; i < spec->nb_entry_points; i++)
+    {
+        ORDDEF *odp = &spec->entry_points[i];
+
+        if (odp->type != TYPE_STDCALL && odp->type != TYPE_VARARGS && odp->type != TYPE_CDECL)
+            output( "\t%s 0\n", get_asm_ptr_keyword() );
+        else if (odp->flags & (FLAG_FORWARD|FLAG_IMPORT|FLAG_EXT_LINK))
+            output( "\t%s 0\n", get_asm_ptr_keyword() );
+        else
+        {
+            sprintf(name, "__real_%s", get_link_name( odp ));
+            output( "\t%s %s\n", get_asm_ptr_keyword(), asm_name(name) );
+        }
+    }
+    output( ".L__wine_spec_unix_name:\n" );
+    output( "\t.ascii \"%s.so\"\n", so_name );
+    output( "\t.long 0\n" );
+
+    free(so_name);
+}
+
 /*******************************************************************
  *         output_exports
  *
@@ -1026,6 +1192,7 @@ void output_module( DLLSPEC *spec )
         data_dirs[1] = ".L__wine_spec_imports";   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT] */
     if (spec->nb_resources)
         data_dirs[2] = ".L__wine_spec_resources"; /* DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE] */
+    data_dirs[15] = ".L__wine_spec_fake_funcs";   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_RESERVED] */
 
     output_data_directories( data_dirs );
 
@@ -1165,6 +1332,7 @@ void output_spec32_file( DLLSPEC *spec )
         output_syscall_thunks_x86( spec );
     else if (target_cpu == CPU_x86_64)
         output_syscall_thunks_x64( spec );
+    output_fakedll_dispatcher( spec );
     output_stubs( spec );
     output_relay_data( spec );
     if (needs_get_pc_thunk) output_get_pc_thunk();
@@ -1295,9 +1463,6 @@ void output_wrap_file( DLLSPEC *spec )
 
         name = asm_name( get_link_name( odp ) );
         output( "-Wl,--wrap=%s\n", name );
-        if (odp->flags & FLAG_SYSCALL) continue;
-
-        output( "-Wl,--defsym=__wrap_%s=__real_%s\n", name, name );
     }
     if (spec32) free_dll_spec( spec32 );
 }
-- 
2.27.0

